/* Robert Nowak, PROBI, 2005-12-15, 15:30
   wzorce, wyjatki */

#ifndef WYJATKI_H_
#define WYJATKI_H_
/*
  ZADANIA:
  1. Przeanalizowac dostarczony przyklad.
  2. Uzupelnic implementacje wyjatku zglaszanego, gdy stos (lifo) jest pusty (EmptyLifoException)
  tak, aby dostarczyc uzytkownikowi odpowiedni komunikat.
  3. Uzupelnic implementacje wyjatku zglaszanego, gdy stos (lifo) jest pelny (FullLifoException)
  tak, aby dostarczyc uzytkownikowi odpowiedni komunikat.
*/

#include <exception>
#include <iostream>

namespace cont
{
    /* Klasa bazowa wyjatkow dla Lifo */
    class LifoException : public std::exception
	{
	public:
		LifoException(long id) : id_(id) {}
		virtual ~LifoException() throw() {}
		virtual void write(std::ostream& os) const = 0;
	protected:
		long id_;
	};

	/* f. globalna, drukuje obiekt na ekranie */
	extern std::ostream& operator<<(std::ostream& os, const LifoException& ex);

    /* wyjatek gdy bledny rozmiar Lifo */
    class BadSizeException : public LifoException
	{
	public:
		BadSizeException(long id, int bad_size ) : LifoException(id), size_(bad_size) {}
		virtual ~BadSizeException() throw() {}

		virtual void write(std::ostream& os) const
		{
			os << "Rozmiar nie moze byc " << size_ <<  " dla stosu id= " << id_ << ".";
		}
	private:
		const int size_;
	};

    /* wyjatek wolany gdy pusty stos i ktos chce czytac */
    class EmptyLifoException : public LifoException
	{
	public:
		EmptyLifoException(long id) : LifoException(id) {}
		virtual ~EmptyLifoException() throw() {}
		virtual void write(std::ostream& os) const
		{
			//ZADANIE - dokonczyc implementacje
		}
	};

    /* wyjatek wolany gdy pelny stos i ktos chce pisac */
    //ZADANIE - zaimplementowac
    class FullLifoException;

}

#endif // WYJATKI_H_

